/* 
 *  This program is an interactive FAQ to ease investigations.
 *  Copyright (C) 2012 Julien Bruguier.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */ 

#ifndef __INVESTIGATION_ANALYSEUR_ANALYSEUR__
#define __INVESTIGATION_ANALYSEUR_ANALYSEUR__
#include <cstdio>
#include <string>
#include <deque>

#include <src/global/global.h>
namespace Investigation { namespace Analyseur { DECL_SHARED_PTR(Analyseur); } }
#include <src/global/exceptions.h>
#include <src/global/sources/position.h>
#include <src/investigation/donnees/site.h>

namespace Investigation
{
	namespace Analyseur
	{
		class Analyseur
		{
			public:
				static Investigation::Donnees::SiteSP analyse(const std::string& fichier);
			private:
				~Analyseur();
				Analyseur() {};
				static FILE *ouvrir(std::string fichier, Investigation::Global::Source::Position& position);
				static bool teste_fichier(std::string fichier);
		};
	}
}
#endif
