/* 
 *  This program is an interactive FAQ to ease investigations.
 *  Copyright (C) 2012 Julien Bruguier.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */ 

#ifndef __INVESTIGATION_DONNEES_INSTRUCTION__
#define __INVESTIGATION_DONNEES_INSTRUCTION__

#include <vector>
#include <set>
#include <string>
#include <src/global/global.h>
namespace Investigation { namespace Donnees { DECL_SHARED_PTR(Instruction); typedef std::vector<InstructionSP> SequenceInstructions; } }
#include <src/global/sources/position.h>
#include <src/investigation/donnees/requete.h>

namespace Investigation
{
	namespace Donnees
	{
		DECL_SHARED_PTR(Page);
		typedef std::vector<PageSP> SequencePages;
		class Instruction
		{
			public:
				explicit Instruction(const Investigation::Global::Source::PositionSP& position)
				:_position(position) { };
				virtual ~Instruction() {};
				virtual Investigation::Donnees::SequencePages operator() (const Investigation::Donnees::Requete& requete) const = 0;
				virtual std::set<std::string> identifiants() const = 0;
				virtual void liens_valides(const std::set<std::string>& identifiants) const = 0;
				virtual void propage_infos() = 0;
			private:
				Investigation::Global::Source::PositionSP _position;
		};
	}
}
#endif
