/* 
 *  This program is an interactive FAQ to ease investigations.
 *  Copyright (C) 2012 Julien Bruguier.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */ 

#include <src/investigation/donnees/requete.h>

using namespace Investigation::Donnees;
#include <src/investigation/donnees/liens.h>

std::vector<std::pair<std::string, Requete::MotClef> > Requete::historique(Investigation::Donnees::Liens& liens) const
{
	Requete requete;
	std::vector<std::pair<std::string, Requete::MotClef> > historique;
	for(auto it=_liste.cbegin() ; it!=_liste.cend() ; ++it)
	{
		historique.push_back(std::pair<std::string,Requete::MotClef>(liens[requete],*it));
		requete = requete << (*it);
	}
	return historique;
}
