/* 
 *  This program is an interactive FAQ to ease investigations.
 *  Copyright (C) 2012 Julien Bruguier.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */ 

#ifndef __INVESTIGATION_DONNEES_TEXTE__
#define __INVESTIGATION_DONNEES_TEXTE__

#include <vector>
#include <src/global/global.h>
namespace Investigation { namespace Donnees { DECL_SHARED_PTR(Texte); } }
#include <src/investigation/donnees/page.h>

namespace Investigation
{
	namespace Donnees
	{
		class Texte : public ContenuPage
		{
			public:
				explicit Texte(const std::string& texte)
				:_texte(texte) { };
				virtual ~Texte() {};
				virtual Html::SequenceContenuDiv operator() (const std::string& methode, const Investigation::Donnees::Requete& requete, Investigation::Donnees::Liens& liens) const
				{
					Html::P texte("investigation page text");
					texte << _texte;
					Html::SequenceContenuDiv seq;
					seq.push_back(texte);
					return seq;
				}
				virtual void liens_valides(const std::set<std::string>& identifiants) const
				{
				};
				virtual void propage_infos(const std::string& page)
				{
				};
			private:
				std::string _texte;
		};
	}
}
#endif
